#include "stdafx.h"

#include "TcpServer.h"
#include "TcpSocket.h"
#include "TcpListenSocket.h"

#define OPTION_FILE_PATH _T(".\\IOCP_Server.ini")

TcpServer::TcpServer()
{
	Proactor_		= NULL;
	Acceptor_		= NULL;
	Receiver_		= NULL;
	Sender_			= NULL;
	Disconnector_	= NULL;

	Port_			= GetPrivateProfileInt( _T("Info"), _T("Port"), 11111, OPTION_FILE_PATH );
	ThreadPoolSize_ = GetPrivateProfileInt( _T("Info"), _T("ThreadPoolSize"), 3, OPTION_FILE_PATH );
	SocketPoolSize_ = GetPrivateProfileInt( _T("Info"), _T("SocketPoolSize"), 1000, OPTION_FILE_PATH );
}


void TcpServer::Start()
{
	Proactor_		= new Proactor;
	Acceptor_		= new Acceptor;
	Receiver_		= new Receiver;
	Sender_			= new Sender;
	Disconnector_	= new Disconnector;

	// Proactor ʱȭ
	Proactor_->Init( ThreadPoolSize_ );

	// Listen  ʱȭ
	ListenSocket_.Init( Port_ );
	
	// Listen 
	ListenSocket_.Listen( Proactor_ );

	// Acceptor ʱȭ - Disconnector ؼ Ǯ Ѵ.
	Acceptor_->Init( &ListenSocket_, Proactor_ );
	
	// Receiver ʱȭ - Ǯ Ѵ. ͼۼ, Ľó
	Receiver_->Init( Proactor_ );

	// Disconnector ʱȭ - Acceptor ؼ Ǯ Ѵ
	Disconnector_->Init( Proactor_ );

	// Sender ʱȭ
	Sender_->Init( Proactor_ );
	
	// Ǯ 
	for( int i=0; i<SocketPoolSize_; i++ )
	{
		TcpSocket* socket = new TcpSocket;
		socket->Init();
		socket->InitAct( Proactor_, Acceptor_, Disconnector_, Sender_, Receiver_ );

		Acceptor_->Register( *socket );
	}
	
}